%ifnos darwin
%define __defattr	%defattr(-,root,root)
%define __soext		so
%else
%define __defattr	%defattr(-,root,wheel)
%define __soext		dylib
%endif

%define VER 5.5.7
%define Patchlevel %{nil}

Summary: An X application for displaying and manipulating images.
Name: ImageMagick

%if "%{Patchlevel}" != ""
Version: %{VER}.%{Patchlevel}
%else
Version: %{VER}
%endif
Release: 1a

License: freeware
Group: Applications/Multimedia
%if "%{Patchlevel}" != ""
Source: ftp://ftp.ImageMagick.org/pub/ImageMagick/ImageMagick-%{VER}-%{Patchlevel}.tar.gz
%else
Source: ftp://ftp.ImageMagick.org/ImageMagick/ImageMagick-%{version}.tar.gz
%endif
Url: http://www.imagemagick.org/

Buildroot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: bzip2-devel, freetype-devel, libjpeg-devel
%ifnos darwin
BuildPrereq: libtiff-devel, libungif-devel, zlib-devel, perl
BuildPrereq: freetype2-devel >= 2.0.1, libpng-devel >= 1.2.5
Requires: bzip2, freetype2, libjpeg, libpng, libtiff, libungif, zlib
%else
BuildPrereq: libtiff-devel
Requires: libjpeg, libpng, libtiff
%endif


%description
ImageMagick(TM) is an image display and manipulation tool for the X
Window System. ImageMagick can read and write JPEG, TIFF, PNM, GIF,
and Photo CD image formats. It can resize, rotate, sharpen, color
reduce, or add special effects to an image, and when finished you can
either save the completed work in the original format or a different
one. ImageMagick also includes command line programs for creating
animated or transparent .gifs, creating composite images, creating
thumbnail images, and more.

ImageMagick is one of your choices if you need a program to manipulate
and dis play images. If you want to develop your own applications
which use ImageMagick code or APIs, you need to install
ImageMagick-devel as well.


%package devel
Summary: Static libraries and header files for ImageMagick app development.
Group: Development/Libraries
Requires: ImageMagick = %{version}-%{release}

%description devel
Image-Magick-devel contains the static libraries and header files you'll
need to develop ImageMagick applications. ImageMagick is an image
manipulation program.

If you want to create applications that will use ImageMagick code or
APIs, you need to install ImageMagick-devel as well as ImageMagick.
You do noy need to install it if you just want to use ImageMagick,
however.

%package perl
Summary: ImageMagick perl bindings
Group: System Environment/Libraries
%ifnos darwin
Requires: ImageMagick = %{version}-%{release}, perl >= 5.8.0
%else
Requires: ImageMagick = %{version}-%{release}
%endif


%description perl
Perl bindings to ImageMagick.

Install ImageMagick-perl if you want to use any perl scripts that use
ImageMagick.


%package c++
Summary: ImageMagick Magick++ library (C++ bindings)
Group: System Environment/Libraries
Requires: ImageMagick = %{version}-%{release}


%description c++
This package contains the Magick++ library, a C++ binding to the ImageMagick
graphics manipulation library.

Install ImageMagick-c++ if you want to use any applications that use Magick++.

%package c++-devel
Summary: C++ bindings for the ImageMagick library
Group: Development/Libraries
Requires: ImageMagick = %{version}, ImageMagick-c++ = %{version}, ImageMagick-devel = %{version}


%description c++-devel
ImageMagick-devel contains the static libraries and header files you'll
need to develop ImageMagick applications using the Magick++ C++ bindings.
ImageMagick is an image manipulation program.

If you want to create applications that will use Magick++ code
or APIs, you'll need to install ImageMagick-c++-devel, ImageMagick-devel and
ImageMagick.
You don't need to install it if you just want to use ImageMagick, or if you
want to develop/compile applications using the ImageMagick C interface,
however.


%prep
%setup -q -n %{name}-%{VER}


%build
%ifnos darwin
libtoolize --force
aclocal
automake || :
autoconf || :
%configure --enable-shared \
           --with-perl \
	   --with-x \
           --with-threads \
           --with-magick_plus_plus \
	   --without-xml --without-wmf
%else
%configure --enable-shared \
           --with-perl \
	   --with-x \
           --with-threads \
           --with-magick_plus_plus \
	   --without-xml --without-wmf \
	   --x-includes='/usr/X11R6/include -I/usr/local/include/libpng'
%endif
make


%install
rm -rf $RPM_BUILD_ROOT

make PerlMagick/Makefile
perl -pi -e 's,^PREFIX = /,PREFIX = \$(DESTDIR)/,g;s,^(INSTALL[A-Z][A-Z]*) = /,\1 = \$(DESTDIR)/,g;s,^config :: Makefile,config :: ,g;s,Makefile : ,Foo : ,g' PerlMagick/Makefile
perl -pi -e "s,-lMagick,-L../magick/.libs -lMagick,g" PerlMagick/Makefile
cat >>PerlMagick/Makefile <<EOF
Makefile:
	touch Makefile
EOF
perl -pi -e 's,^install-exec-perl:.*,install-exec-perl:,g' Makefile
rm -f PerlMagick/Makefile.*
make install DESTDIR=$RPM_BUILD_ROOT


# Add files make install constantly forgets
install -c -m 644 coders/*.mgk $RPM_BUILD_ROOT%{_datadir}/ImageMagick

find $RPM_BUILD_ROOT -name "*.bs" -exec rm -f {} \;
find $RPM_BUILD_ROOT -name ".packlist" -exec rm -f {} \;

%ifnos darwin
pushd $RPM_BUILD_ROOT/%{_bindir}
for i in %{_arch}-vine-linux-gnu-*; do
        [ -f $i ] && mv $i `echo $i |sed -e "s/^%{_arch}-vine-linux-gnu-//"`
done
for i in %{_arch}-vine-linux-*; do
        [ -f $i ] && mv $i `echo $i |sed -e "s/^%{_arch}-vine-linux-//"`
done
popd

pushd $RPM_BUILD_ROOT/%{_mandir}
for i in */%{_arch}-vine-linux-gnu-*; do
        [ -f $i ] && mv $i `echo $i |sed -e "s,/%{_arch}-vine-linux-gnu-,/,"`
done
for i in */%{_arch}-vine-linux-*; do
        [ -f $i ] && mv $i `echo $i |sed -e "s,/%{_arch}-vine-linux-,/,"`
done
popd
%else
pushd $RPM_BUILD_ROOT/%{_bindir}
for i in %{_arch}-apple-darwin-*; do
        [ -f $i ] && mv $i `echo $i |sed -e "s/^%{_arch}-apple-darwin-//"`
done
popd

pushd $RPM_BUILD_ROOT/%{_mandir}
for i in */%{_arch}-apple-darwin-*; do
        [ -f $i ] && mv $i `echo $i |sed -e "s,/%{_arch}-apple-darwin-,/,"`
done
popd
%endif


# get the perl file list. We know what we need, so this is easy
echo "%{__defattr}" > perl-pkg-files
%ifnos darwin
find $RPM_BUILD_ROOT%{_libdir}/perl$perlmajor/site_perl/$perlver -type d -name Image >> perl-pkg-files.orig
%else
find $RPM_BUILD_ROOT/Library/Perl/darwin -type d -name Image >> perl-pkg-files.orig
%endif
sed -e s,$RPM_BUILD_ROOT,, perl-pkg-files.orig > perl-pkg-files

%ifnos darwin
# remove files we aren't shipping 
rm -f `find $RPM_BUILD_ROOT%{_libdir}/perl$perlmajor/ -name perllocal.pod -type f`
%endif

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig


%post c++ -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%postun c++ -p /sbin/ldconfig


%files
%{__defattr}
%doc www images
%doc README.txt index.html
%ifnos darwin
%attr(755,root,root) %{_libdir}/libMagick.so.*
%else
%attr(-,root,wheel) %{_libdir}/libMagick.*.dylib
%endif
%{_bindir}/[a-z]*
%{_mandir}/*/*
%{_datadir}/ImageMagick
%{_libdir}/ImageMagick-*


%files devel
%{__defattr}
%{_bindir}/Magick*
%{_libdir}/libMagick.a
%{_libdir}/libMagick.la
%{_libdir}/libMagick.%{__soext}
%{_includedir}/magick


%files c++
%{__defattr}
%ifnos darwin
%{_libdir}/libMagick++.so.*
%else
%{_libdir}/libMagick++.*.dylib
%endif


%files c++-devel
%{__defattr}
%{_includedir}/Magick++
%{_includedir}/Magick++.h
%{_libdir}/libMagick++.a
%{_libdir}/libMagick++.la
%{_libdir}/libMagick++.%{__soext}


%files perl -f perl-pkg-files
%{__defattr}


%changelog
* Thu May 15 2003 Keisuke Fujii <fujiik@jlcuxf.kek.jp> 5.5.7-1a
- 1st build on MacOS X 10.2

